#!/bin/sh
############################################################################
#                                                                          #
#  Copyright (c) 2001, 2011 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of Medialogic S.p.A.                    #
#                                                                          #
#  All rigths reserved.                                                    #
#                                                                          #
############################################################################
PATH="$PATH:/usr/bin:/bin:/usr/local/bin" && export PATH
NODE_ROOT='/usr/NX'
COMMAND_ECHO="/bin/echo"
COMMAND_CAT="/bin/cat"
COMMAND_UMOUNT="/bin/umount"

if [ ! -x $COMMAND_UMOUNT ];
then
  if [ -x "/sbin/umount" ];
  then
    COMMAND_UMOUNT="/sbin/umount"
  elif [ -x "/usr/sbin/umount" ];
  then
    COMMAND_UMOUNT="/usr/sbin/umount"
  elif [ -x "/usr/bin/umount" ];
  then
    COMMAND_UMOUNT="/usr/bin/umount"
  elif [ -x "/usr/local/bin/umount" ];
  then
    COMMAND_UMOUNT="/usr/local/bin/umount"
  elif [ -x "/usr/local/sbin/umount" ];
  then
    COMMAND_UMOUNT="/usr/local/sbin/umount"
  else 
    echo "Error: Cannot umount share $3, missing command $COMMAND_UMOUNT in $PATH. Cannot use NX smb privilegd script to umount share."
    exit 1
  fi
fi

checkPpid() {

  if [ "x$1" = "x" ];
  then
    $COMMAND_ECHO "Missing pid"
    return 1
  fi
  if [ ! -e /proc/$1/cmdline ];
  then
    $COMMAND_ECHO "Wrong pid: $1"
    return 1
  fi

  command=$(/bin/cat /proc/$1/cmdline)

  $COMMAND_ECHO "$command"
}

command=$(checkPpid $2)

if [ $? != 0 ];
then
  $COMMAND_ECHO "NX> 500 Error: $command"
  exit 1
fi

if [ "$command" != "$NODE_ROOT/bin/nxnode" ];
then
  $COMMAND_ECHO "NX> 500 Error: Only the nxnode or nxserver can run this script.\n";
  exit 1
fi

if [ -x $COMMAND_UMOUNT ];
then 
  if [ "x$4" != "x-l" ];
  then
    exec $COMMAND_UMOUNT "$3"
  else  
    exec $COMMAND_UMOUNT -li "$3"
  fi
else
 $COMMAND_ECHO "NX> 599 Error: command $COMMAND_UMOUNT doesn't exist anymore in $PATH."
 exit 1
fi
