#!/bin/sh
############################################################################
#                                                                          #
#  Copyright (c) 2001, 2011 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of Medialogic S.p.A.                    #
#                                                                          #
#  All rigths reserved.                                                    #
#                                                                          #
############################################################################
ice_dir=/tmp/.ICE-unix;
x11_dir=/tmp/.X11-unix;

COMMAND_ECHO="/bin/echo"
NODE_ROOT="/usr/NX"

checkPpid() {

  if [ "x$1" = "x" ];
  then
    $COMMAND_ECHO "Missing pid"
    return 1
  fi
  if [ ! -e /proc/$1/cmdline ];
  then
    $COMMAND_ECHO "Wrong pid: $1"
    return 1
  fi

  command=$(/bin/cat /proc/$1/cmdline)

  $COMMAND_ECHO "$command"
}

command=$(checkPpid $2)

if [ $? != 0 ];
then
  $COMMAND_ECHO "NX> 500 Error: $command"
  exit 1
fi

if [ "$command" != "$NODE_ROOT/bin/nxnode" ];
then
  $COMMAND_ECHO "NX> 500 Error: Only the nxnode can run this script.";
  exit 1
fi

for dirname in $ice_dir $x11_dir ; do
{
  if (! [ -d $dirname ] )
  then
    /bin/mkdir $dirname
    if [ $? != 0 ];
    then
      echo "Warning: $0: cannot mkdir $dirname";
    fi
  fi

  if (! [ -O $dirname ] )
  then
    /bin/chown root:root $dirname
    if [ $? != 0 ];
    then
      echo "Warning: $0: cannot chown $dirname";
    fi
  fi

  /bin/chmod 1777 $dirname
  if [ $? != 0 ];
  then
    echo "Warning: $0: cannot chmod $dirname to 1777";
  fi
}
done

test -x /sbin/restorecon && /sbin/restorecon -v /tmp/.X11-unix

